Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/TreeView/IItemTreeAction.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/TreeView/IItemTreeAction.cs	(revision 6033)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/TreeView/IItemTreeAction.cs	(revision 6033)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Clients.Hive {
+  public interface IItemTreeNodeAction<T> where T : IItemTree<T> {
+    string Name { get; }
+    Image Image { get; }
+    void Execute(T item, T parentItem);
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 6033)
@@ -122,5 +122,9 @@
     <Compile Include="ExperimentManager\ExperimentManagerClient.cs" />
     <Compile Include="ExperimentManager\HiveJobDownloader.cs" />
-    <Compile Include="ExperimentManager\IItemTree.cs" />
+    <Compile Include="ExperimentManager\TreeView\IItemTree.cs" />
+    <Compile Include="ExperimentManager\TreeView\IItemTreeAction.cs" />
+    <Compile Include="ExperimentManager\OptimizerHiveJob.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="ExperimentManager\PluginClient.cs" />
     <Compile Include="Exceptions\ResourceNotFoundException.cs" />
@@ -146,4 +150,6 @@
     <Compile Include="ServiceClients\HiveItem.cs" />
     <Compile Include="ServiceClients\JobData.cs" />
+    <Compile Include="ServiceClients\OperationJob.cs" />
+    <Compile Include="ExperimentManager\RefreshableHiveExperiment.cs" />
     <Compile Include="ServiceClients\Plugin.cs" />
     <Compile Include="ServiceClients\PluginData.cs" />
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLabClientsHivePlugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLabClientsHivePlugin.cs.frame	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLabClientsHivePlugin.cs.frame	(revision 6033)
@@ -8,6 +8,12 @@
   [Plugin("HeuristicLab.Clients.Hive", "3.4.0.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Hive", "3.4")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabClientsHivePlugin : PluginBase {
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/Jobs/OptimizerJob.cs	(revision 6033)
@@ -22,5 +22,4 @@
 using System;
 using System.Collections.Generic;
-using System.Drawing;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -32,21 +31,12 @@
   [Item("Optimizer Job", "Represents Job which executes a IOptimizer object.")]
   [StorableClass]
-  public class OptimizerJob : AbstractJob {
+  public class OptimizerJob : ItemJob {
     public override bool IsParallelizable {
-      get { return this.Optimizer is Optimization.Experiment || this.Optimizer is BatchRun; }
+      get { return this.Item is Experiment || this.Item is BatchRun; }
     }
 
-    [Storable]
-    protected IOptimizer optimizer;
-    public IOptimizer Optimizer {
-      get { return optimizer; }
-      set {
-        if (value != optimizer) {
-          if (optimizer != null) DeregisterOptimizerEvents();
-          optimizer = value;
-          if (optimizer != null) RegisterOptimizerEvents();
-          OnOptimizerChanged();
-        }
-      }
+    public new IOptimizer Item {
+      get { return (IOptimizer)base.Item; }
+      set { base.Item = value; }
     }
 
@@ -58,14 +48,12 @@
     }
 
-    public OptimizerJob() : base() {
-      
-    }
+    public OptimizerJob() : base() { }
     public OptimizerJob(IOptimizer optimizer)
       : this() {
-      this.Optimizer = optimizer;
+        this.Item = optimizer;
 
-      if (optimizer is Optimization.Experiment) {
+      if (optimizer is Experiment) {
         this.ComputeInParallel = true;
-      } else if (optimizer is Optimization.BatchRun) {
+      } else if (optimizer is BatchRun) {
         this.ComputeInParallel = false;
       } else {
@@ -77,8 +65,6 @@
     protected OptimizerJob(OptimizerJob original, Cloner cloner)
       : base(original, cloner) {
-      this.Optimizer = cloner.Clone(original.Optimizer);
       this.IndexInParentOptimizerList = original.IndexInParentOptimizerList;
       this.CollectChildJobs = original.CollectChildJobs;
-      this.RegisterOptimizerEvents();
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -86,14 +72,9 @@
     }
 
-    [StorableHook(HookType.AfterDeserialization)]
-    protected virtual void AfterDeserialization() {
-      RegisterOptimizerEvents();
-    }
-
     /// <summary>
     /// Casts the Optimizer to an Experiment. Returns null if cast was not successfull.
     /// </summary>
-    public Optimization.Experiment OptimizerAsExperiment {
-      get { return Optimizer as Optimization.Experiment; }
+    public Experiment OptimizerAsExperiment {
+      get { return Item as Experiment; }
     }
 
@@ -101,6 +82,6 @@
     /// Casts the Optimizer to an BatchRun. Returns null if cast was not successfull.
     /// </summary>
-    public Optimization.BatchRun OptimizerAsBatchRun {
-      get { return Optimizer as Optimization.BatchRun; }
+    public BatchRun OptimizerAsBatchRun {
+      get { return Item as BatchRun; }
     }
 
@@ -108,30 +89,30 @@
 
     public override ExecutionState ExecutionState {
-      get { return optimizer.ExecutionState; }
+      get { return Item.ExecutionState; }
     }
 
     public override TimeSpan ExecutionTime {
-      get { return optimizer.ExecutionTime; }
+      get { return Item.ExecutionTime; }
     }
 
     public override void Prepare() {
-      optimizer.Prepare();
+      Item.Prepare();
     }
 
     public override void Start() {
-      if ((optimizer is Optimization.Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
-          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Optimizer == null)) { // batchrun would not fire OnStopped if algorithm == null
+      if ((Item is Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
+          (Item is BatchRun && OptimizerAsBatchRun.Optimizer == null)) { // batchrun would not fire OnStopped if algorithm == null
         OnJobStopped();
       } else {
-        optimizer.Start();
+        Item.Start();
       }
     }
 
     public override void Pause() {
-      optimizer.Pause();
+      Item.Pause();
     }
 
     public override void Stop() {
-      optimizer.Stop();
+      Item.Stop();
     }
 
@@ -142,28 +123,22 @@
 
     #region Optimizer Events
-    protected virtual void RegisterOptimizerEvents() {
-      optimizer.Stopped += new EventHandler(optimizer_Stopped);
-      optimizer.Paused += new EventHandler(optimizer_Paused);
-      optimizer.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
-      optimizer.DescriptionChanged += new EventHandler(optimizer_DescriptionChanged);
-      optimizer.ItemImageChanged += new EventHandler(optimizer_ItemImageChanged);
-      optimizer.NameChanged += new EventHandler(optimizer_NameChanged);
-      optimizer.NameChanging += new EventHandler<CancelEventArgs<string>>(optimizer_NameChanging);
-      optimizer.ToStringChanged += new EventHandler(optimizer_ToStringChanged);
+    protected override void RegisterItemEvents() {
+      base.RegisterItemEvents();
+      Item.Stopped += new EventHandler(optimizer_Stopped);
+      Item.Paused += new EventHandler(optimizer_Paused);
+      Item.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      Item.DescriptionChanged += new EventHandler(optimizer_DescriptionChanged);
+      Item.NameChanged += new EventHandler(optimizer_NameChanged);
+      Item.NameChanging += new EventHandler<CancelEventArgs<string>>(optimizer_NameChanging);
     }
 
     protected virtual void DeregisterOptimizerEvents() {
-      optimizer.Stopped -= new EventHandler(optimizer_Stopped);
-      optimizer.Paused -= new EventHandler(optimizer_Paused);
-      optimizer.ExceptionOccurred -= new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
-      optimizer.DescriptionChanged -= new EventHandler(optimizer_DescriptionChanged);
-      optimizer.ItemImageChanged -= new EventHandler(optimizer_ItemImageChanged);
-      optimizer.NameChanged -= new EventHandler(optimizer_NameChanged);
-      optimizer.NameChanging -= new EventHandler<CancelEventArgs<string>>(optimizer_NameChanging);
-      optimizer.ToStringChanged -= new EventHandler(optimizer_ToStringChanged);
-    }
-
-    protected void optimizer_ToStringChanged(object sender, EventArgs e) {
-      this.OnToStringChanged();
+      Item.Stopped -= new EventHandler(optimizer_Stopped);
+      Item.Paused -= new EventHandler(optimizer_Paused);
+      Item.ExceptionOccurred -= new EventHandler<EventArgs<Exception>>(optimizer_ExceptionOccurred);
+      Item.DescriptionChanged -= new EventHandler(optimizer_DescriptionChanged);
+      Item.NameChanged -= new EventHandler(optimizer_NameChanged);
+      Item.NameChanging -= new EventHandler<CancelEventArgs<string>>(optimizer_NameChanging);
+      base.DeregisterItemEvents();
     }
 
@@ -174,8 +149,4 @@
     protected void optimizer_NameChanged(object sender, EventArgs e) {
       this.OnNameChanged();
-    }
-
-    protected void optimizer_ItemImageChanged(object sender, EventArgs e) {
-      this.OnItemImageChanged();
     }
 
@@ -198,40 +169,20 @@
 
     #region INamedItem Members
-
     public override bool CanChangeDescription {
-      get { return optimizer.CanChangeDescription; }
+      get { return Item.CanChangeDescription; }
     }
 
     public override bool CanChangeName {
-      get { return optimizer.CanChangeName; }
+      get { return Item.CanChangeName; }
     }
 
     public override string Description {
-      get { return optimizer.Description; }
-      set { optimizer.Description = value; }
+      get { return Item.Description; }
+      set { Item.Description = value; }
     }
 
     public override string Name {
-      get { return optimizer.Name; }
-      set { optimizer.Name = value; }
-    }
-    #endregion
-    
-    #region IItem Members
-
-    public override string ItemDescription {
-      get { return optimizer.ItemDescription; }
-    }
-
-    public override Image ItemImage {
-      get { return optimizer.ItemImage; }
-    }
-
-    public override string ItemName {
-      get { return optimizer.ItemName; }
-    }
-
-    public override Version ItemVersion {
-      get { return optimizer.ItemVersion; }
+      get { return Item.Name; }
+      set { Item.Name = value; }
     }
     #endregion
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 6033)
@@ -24,8 +24,6 @@
 using System.ComponentModel;
 using System.Linq;
-using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,6 +31,4 @@
   [StorableClass]
   public partial class HiveExperiment : IDeepCloneable, IContent, IProgressReporter {
-    private JobResultPoller jobResultPoller;
-
     [Storable]
     private bool useLocalPlugins;
@@ -71,8 +67,6 @@
       get { return hiveJobs; }
       set {
-        DeregisterHiveJobsEvents();
         if (hiveJobs != value) {
           hiveJobs = value;
-          RegisterHiveJobsEvents();
           OnHiveJobsChanged();
         }
@@ -92,29 +86,4 @@
     }
 
-    /** include jobs when refreshing **/
-    [Storable]
-    private bool includeJobs;
-    public bool IncludeJobs {
-      get { return includeJobs; }
-      set { includeJobs = value; }
-    }
-
-    [Storable]
-    private bool refreshAutomatically;
-    public bool RefreshAutomatically {
-      get { return refreshAutomatically; }
-      set {
-        if (refreshAutomatically != value) {
-          refreshAutomatically = value;
-          OnRefreshAutomaticallyChanged();
-          if (RefreshAutomatically) {
-            StartResultPolling();
-          } else {
-            StopResultPolling();
-          }
-        }
-      }
-    }
-
     [Storable]
     private IProgress progress;
@@ -127,6 +96,5 @@
     public HiveExperiment() {
       this.ResourceNames = "HEAL";
-      this.includeJobs = true;
-      this.refreshAutomatically = true;
+      this.HiveJobs = new ItemCollection<HiveJob>();
     }
 
@@ -140,5 +108,5 @@
       this.Description = original.Description;
       this.Id = original.Id;
-
+      this.HiveJobs = cloner.Clone(original.HiveJobs);
       this.UseLocalPlugins = original.UseLocalPlugins;
       this.ExecutionTime = original.ExecutionTime;
@@ -148,8 +116,4 @@
     }
     #endregion
-
-    public override string ToString() {
-      return Name;
-    }
 
     #region Events
@@ -167,13 +131,5 @@
 
     public event EventHandler HiveJobsChanged;
-    private void OnHiveJobsChanged() {
-      if (jobResultPoller != null && jobResultPoller.IsPolling) {
-        jobResultPoller.Stop();
-        DeregisterResultPollingEvents();
-      }
-      if (HiveJobs != null && HiveJobs.Count > 0 && GetAllHiveJobs().All(x => x.Job.Id != Guid.Empty)) {
-        if (this.RefreshAutomatically)
-          StartResultPolling();
-      }
+    protected virtual void OnHiveJobsChanged() {
       EventHandler handler = HiveJobsChanged;
       if (handler != null) handler(this, EventArgs.Empty);
@@ -185,53 +141,6 @@
       if (handler != null) handler(this, EventArgs.Empty);
     }
-
-    public event EventHandler RefreshAutomaticallyChanged;
-    private void OnRefreshAutomaticallyChanged() {
-      EventHandler handler = RefreshAutomaticallyChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
     #endregion
-
-    private void RegisterHiveJobsEvents() {
-      //if (HiveJobs != null) {
-      //  HiveJobs.JobStateChanged += new EventHandler(HiveJob_JobStateChanged);
-      //}
-    }
-
-    private void DeregisterHiveJobsEvents() {
-      //if (HiveJobs != null) {
-      //  HiveJobs.JobStateChanged -= new EventHandler(HiveJob_JobStateChanged);
-      //}
-    }
-
-    private void HiveJob_JobStateChanged(object sender, EventArgs e) {
-      //if (this.HiveJobs != null) {
-      //  this.RootJobId = HiveJobs.Job.Id;
-      //}
-    }
-
-    public Experiment GetExperiment(int idx) {
-      if (this.HiveJobs != null) {
-        var hj = HiveJobs.ElementAtOrDefault(idx);
-        if (hj != null)
-          return hj.OptimizerJob.OptimizerAsExperiment;
-      }
-      return null;
-    }
-
-    public void AddExperiment(Experiment experiment) {
-      if (this.HiveJobs == null) 
-        this.HiveJobs = new ItemCollection<HiveJob>();
-      this.HiveJobs.Add(new HiveJob(experiment));
-    }
-
-    public void SetExperiment(Experiment experiment) {
-      if (this.HiveJobs == null)
-        this.HiveJobs = new ItemCollection<HiveJob>();
-      else
-        this.HiveJobs.Clear();
-      this.HiveJobs.Add(new HiveJob(experiment));
-    }
-
+    
     protected override void OnPropertyChanged(PropertyChangedEventArgs e) {
       base.OnPropertyChanged(e);
@@ -240,113 +149,5 @@
       }
     }
-
-    #region JobResultPoller Events
-
-    public void StartResultPolling() {
-      if (jobResultPoller == null) {
-        jobResultPoller = new JobResultPoller(HiveJobs, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5)); //TODO: find a better place for ApplicationConstants
-        RegisterResultPollingEvents();
-      }
-
-      if (!jobResultPoller.IsPolling) {
-        jobResultPoller.Start();
-      }
-    }
-
-    public void StopResultPolling() {
-      if (jobResultPoller != null && jobResultPoller.IsPolling) {
-        jobResultPoller.Stop();
-      }
-    }
-
-    private void RegisterResultPollingEvents() {
-      jobResultPoller.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
-      jobResultPoller.JobResultsReceived += new EventHandler<EventArgs<IEnumerable<LightweightJob>>>(jobResultPoller_JobResultReceived);
-      jobResultPoller.IsPollingChanged += new EventHandler(jobResultPoller_IsPollingChanged);
-    }
-    private void DeregisterResultPollingEvents() {
-      jobResultPoller.ExceptionOccured -= new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
-      jobResultPoller.JobResultsReceived -= new EventHandler<EventArgs<IEnumerable<LightweightJob>>>(jobResultPoller_JobResultReceived);
-      jobResultPoller.IsPollingChanged -= new EventHandler(jobResultPoller_IsPollingChanged);
-    }
-    private void jobResultPoller_IsPollingChanged(object sender, EventArgs e) {
-      this.refreshAutomatically = jobResultPoller.IsPolling;
-      OnRefreshAutomaticallyChanged();
-    }
-    private void jobResultPoller_JobResultReceived(object sender, EventArgs<IEnumerable<LightweightJob>> e) {
-      foreach (LightweightJob lightweightJob in e.Value) {
-        HiveJob hj = GetHiveJobById(lightweightJob.Id);
-        if (hj != null) {
-          DateTime lastJobDataUpdate = hj.Job.LastJobDataUpdate;
-          hj.UpdateFromLightweightJob(lightweightJob);
-
-          // lastJobDataUpdate equals DateTime.MinValue right after it was uploaded. When the first results are polled, this value is updated
-          if (lastJobDataUpdate != DateTime.MinValue && lastJobDataUpdate < hj.Job.LastJobDataUpdate) {
-            OptimizerJob optimizerJob = ExperimentManagerClient.LoadOptimizerJob(hj.Job.Id);
-            if (optimizerJob == null) {
-              // something bad happened to this job. bad job, BAAAD job!
-            } else {
-              // if the job is paused, download but don't integrate into parent optimizer (to avoid Prepare)
-              if (hj.Job.State == JobState.Paused) {
-                hj.OptimizerJob = optimizerJob;
-              } else {
-                if (lightweightJob.ParentJobId.HasValue) {
-                  HiveJob parentHiveJob = GetHiveJobById(lightweightJob.ParentJobId.Value);
-                  parentHiveJob.UpdateChildOptimizer(optimizerJob, hj.Job.Id);
-                }
-              }
-            }
-          }
-        }
-      }
-      GC.Collect(); // force GC, because .NET is too lazy here (deserialization takes a lot of memory)
-      if (AllJobsFinished()) {
-        this.ExecutionState = Core.ExecutionState.Stopped;
-        StopResultPolling();
-        //OnStopped();
-      }
-      UpdateTotalExecutionTime();
-      UpdateStats();
-    }
-
-    public HiveJob GetHiveJobById(Guid jobId) {
-      foreach (HiveJob job in HiveJobs) {
-        HiveJob hj = job.GetHiveJobByJobId(jobId);
-        if (hj != null)
-          return hj;
-      }
-      return null;
-    }
-
-    private void UpdateStats() {
-      var jobs = GetAllHiveJobs();
-      this.JobCount = jobs.Count();
-      this.CalculatingCount = jobs.Count(j => j.Job.State == JobState.Calculating);
-      this.FinishedCount = jobs.Count(j => j.Job.State == JobState.Finished);
-    }
-
-    public IEnumerable<HiveJob> GetAllHiveJobs() {
-      var jobs = new List<HiveJob>();
-      foreach (HiveJob job in HiveJobs) {
-        jobs.AddRange(job.GetAllHiveJobs());
-      }
-      return jobs;
-    }
-
-    public bool AllJobsFinished() {
-      return GetAllHiveJobs().All(j => j.Job.State == JobState.Finished
-                                            || j.Job.State == JobState.Aborted
-                                            || j.Job.State == JobState.Failed);
-    }
-
-    private void jobResultPoller_ExceptionOccured(object sender, EventArgs<Exception> e) {
-      //OnExceptionOccured(e.Value);
-    }
-
-    public void UpdateTotalExecutionTime() {
-      this.ExecutionTime = TimeSpan.FromMilliseconds(GetAllHiveJobs().Sum(x => x.Job.ExecutionTime.HasValue ? x.Job.ExecutionTime.Value.TotalMilliseconds : 0));
-    }
-    #endregion
-
+    
     protected override void RaisePropertyChanged(string propertyName) {
       if (!(propertyName == "ExecutionTime")
@@ -362,4 +163,18 @@
         && HiveJobs.All(x => x.Job.DateFinished.HasValue && x.Job.DateCreated.HasValue);
     }
+
+    public IEnumerable<HiveJob> GetAllHiveJobs() {
+      var jobs = new List<HiveJob>();
+      foreach (HiveJob job in HiveJobs) {
+        jobs.AddRange(job.GetAllHiveJobs());
+      }
+      return jobs;
+    }
+
+    public override string ToString() {
+      return Name;
+    }
+
+    public virtual void OnLoaded() { }
   }
 }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/OperationJob.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/OperationJob.cs	(revision 6033)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/OperationJob.cs	(revision 6033)
@@ -0,0 +1,9 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Clients.Hive.ServiceClients {
+  class OperationJob {
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive/3.4/HeuristicLab.Hive-3.4.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive/3.4/HeuristicLab.Hive-3.4.csproj	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive/3.4/HeuristicLab.Hive-3.4.csproj	(revision 6033)
@@ -96,5 +96,5 @@
     <Compile Include="HeuristicLabHivePlugin.cs" />
     <Compile Include="IJob.cs" />
-    <Compile Include="AbstractJob.cs" />
+    <Compile Include="ItemJob.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
